<?php namespace Phpcmf\Controllers\Admin;

/* *
 *
 * Copyright [2019] [李睿]
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * www.xunruicms.com
 *
 * 本文件是框架系统文件，二次开发时不可以修改本文件
 *
 * */



class Field extends \Phpcmf\Common
{
    private $cloud_field;

    public function __construct(...$params) {
        parent::__construct(...$params);
        $this->table = SITE_ID.'_cloud_buy';
        \Phpcmf\Service::V()->assign([
            'menu' => \Phpcmf\Service::M('auth')->_admin_menu(
                [
                    '字段划分' => ['cloud/field/index', 'fa fa-cog'],
                    '自定义字段' => ['url:'.\Phpcmf\Service::L('Router')->url('field/index', ['rname' => 'table-'.$this->table]), 'fa fa-code'],
                ]
            ),
            'uriprefix' => 'cloud/field'
        ]);
        $this->_module_init('cloud');
        // 字段配置
        $this->cloud_field = \Phpcmf\Service::M('app')->get_config('cloud_field');
    }

    public function index() {

        $color = $list = $group = [];


        // 字段查询
        $field = \Phpcmf\Service::M()->db->table('field')->where('disabled', 0)->where('relatedname', 'table-'.$this->table)->orderBy('displayorder ASC,id ASC')->get()->getResultArray();
        if ($field) {
            foreach ($field as $f) {
                //$f['register'] = in_array($f['id'], $register);
                $f['group'] = $this->cloud_field[$f['id']];
                $list[$f['fieldname']] = $f;
            }
        }

        // 栏目
        $category = $this->get_cache('module-'.SITE_ID.'-cloud', 'category');
        if ($category) {
            $_color = ['blue', 'red', 'green', 'dark', 'yellow'];
            foreach ($category as $i => $t) {
                if ($t['pid'] == 0 && $t['mid'] == 'cloud') {
                    $group[$t['id']] = $t;
                    $color[$t['id']] = $_color[$i];
                }
            }
        }
        
        \Phpcmf\Service::V()->assign([
            'list' => $list,
            'group' => $group,
            'color' => $color,
        ]);
        \Phpcmf\Service::V()->display('field.html');
    }

    public function add() {

        $ids = \Phpcmf\Service::L('input')->get_post_ids();
        !$ids && $this->_json(0, dr_lang('你还没有选择呢'));

        $gid = (int)\Phpcmf\Service::L('input')->post('groupid');
        !$gid && $this->_json(0, dr_lang('你还没有选择栏目'));

        foreach ($ids as $id) {
            $this->cloud_field[$id][$gid] = $gid;
        }

        \Phpcmf\Service::M('app')->save_config('cloud_field', $this->cloud_field);

        \Phpcmf\Service::M('cache')->sync_cache(''); // 自动更新缓存
        $this->_json(1, dr_lang('划分成功'));
    }

    public function del() {

        $fid = (int)\Phpcmf\Service::L('input')->get('fid');
        !$fid && $this->_json(0, dr_lang('字段id不存在'));

        $gid = (int)\Phpcmf\Service::L('input')->get('gid');
        !$gid && $this->_json(0, dr_lang('栏目组id不存在'));


        !$this->cloud_field[$fid][$gid] && $this->_json(0, dr_lang('配置不存在'));

        unset($this->cloud_field[$fid][$gid]);

        \Phpcmf\Service::M('app')->save_config('cloud_field', $this->cloud_field);

        \Phpcmf\Service::M('cache')->sync_cache(''); // 自动更新缓存
        $this->_json(1, dr_lang('删除成功'));
    }


}
