<?php namespace Phpcmf\Controllers\Admin;


// 交易记录
class Order extends \Phpcmf\Table
{

    public function __construct(...$params)
    {
        parent::__construct(...$params);
        // 支持附表存储
        $this->is_data = 0;
        // url显示名称
        $this->name = dr_lang('交易记录');
        // 初始化数据表
        $this->_init([
            'table' => SITE_ID.'_cloud_buy',
            'select_list' =>  SITE_ID.'_cloud_buy.*,'.SITE_ID.'_cloud.title,'.SITE_ID.'_cloud.url',
            'order_by' => SITE_ID.'_cloud_buy.id desc',
            'join_list' => [SITE_ID.'_cloud', SITE_ID.'_cloud_buy.cid='.SITE_ID.'_cloud.id', 'left'],
        ]);
        \Phpcmf\Service::V()->assign([
            'menu' => \Phpcmf\Service::M('auth')->_admin_menu(
                [
                    '交易记录' => [APP_DIR.'/'.\Phpcmf\Service::L('Router')->class.'/index', 'fa fa-rmb'],
                    '详情' => ['hide:'.APP_DIR.'/'.\Phpcmf\Service::L('Router')->class.'/edit', 'fa fa-edit'],
                ]
            ),
        ]);
    }

    // 后台查看url列表
    public function index() {
        $this->_List();
        \Phpcmf\Service::V()->display('order_list.html');
    }

    // 删除
    public function del() {
        $this->_Del(\Phpcmf\Service::L('input')->get_post_ids());
    }

    public function edit() {

        $id = intval($_GET['id']);
        $data = \Phpcmf\Service::M()->db->table(SITE_ID.'_cloud_buy')->where('id', $id)->get()->getRowArray();
        if (!$data) {
            $this->_msg(0, '购买记录不存在');
        }

        $shop = \Phpcmf\Service::M()->db->table(SITE_ID.'_cloud')->where('id', $data['cid'])->get()->getRowArray();

        $this->_module_init('cloud');
        $field = $this->content_model->get_buy_field($shop['catid']);

        if (IS_POST) {
            $post = \Phpcmf\Service::L('input')->post('data');
            list($post, $return, $attach) = \Phpcmf\Service::L('Form')->validation($post, [], $field, []);
            // 输出错误
            $return && $this->_json(0, $return['error'], ['field' => $return['name']]);
            if ($post[1]) {
                $rt = \Phpcmf\Service::M()->table(SITE_ID.'_cloud_buy')->update($id, $post[1]);
                !$rt['code'] && $this->_json(0, $rt['msg'], $rt['data']);
                // 附件归档
                SYS_ATTACHMENT_DB && $attach && \Phpcmf\Service::M('Attachment')->handle($this->member['id'], \Phpcmf\Service::M()->dbprefix(SITE_ID.'_cloud_buy-'.$rt['code']), $attach);
            }
            $this->_json(1, '保存成功');
        }

        \Phpcmf\Service::V()->assign([
            'shop' => $shop,
            'order' => $data,
            'myfield' => \Phpcmf\Service::L('Field')->toform($id, $field, $data),
        ]);
        \Phpcmf\Service::V()->display('order_show.html');
    }

    // 云端通信
    public function yun() {

        $id = intval($_GET['id']);
        $data = \Phpcmf\Service::M()->table(SITE_ID.'_cloud_buy')->get($id);
        if (!$data) {
            $this->_json(0, '交易[#'.$id.']记录不存在');
        } elseif ($data['status'] > 0) {
            $this->_json(1, '交易已经成功');
        } elseif ($data['status'] == -1) {
            $this->_json(0, '交易没有付款');
        } elseif (!$data['cloud_id']) {
            $this->_json(1, '不是云端资源，不能通信');
        }

        $shop = \Phpcmf\Service::M()->table(SITE_ID.'_cloud')->get($data['cid']);
        if (!$shop) {
            $this->_json(0, '商品['.$data['cid'].']不存在');
        } elseif ($shop['status'] != 9) {
            $this->_json(0, '商品['.$shop['title'].']已下架');
        }

        $rt = \Phpcmf\Service::M('zy', 'cloud')->tx($data);

        if ($rt['code']) {
            \Phpcmf\Service::M()->table(SITE_ID.'_cloud_buy')->update($id, [
                'status' => 1,
                'error' => '',
            ]);
            $this->_json(1, '交易完成');
        } else {
            \Phpcmf\Service::M()->table(SITE_ID.'_cloud_buy')->update($id, [
                'status' => 0,
                'error' => $rt['msg'],
            ]);
        }

        $this->_json(0, $rt['msg']);
    }

}
