<?php namespace Phpcmf\Controllers\Admin;

class Zy extends \Phpcmf\Common
{
    private $service_url;

    public function __construct(...$params)
    {
        parent::__construct(...$params);
        $this->service_url = \Phpcmf\Service::M('zy', 'cloud')->get_service_url();

    }

    // 云端资源
    public function index() {

        \Phpcmf\Service::V()->assign([
            'url' => $this->service_url.'&action=app',
        ]);
        \Phpcmf\Service::V()->display('cloud_online.html');exit;
    }

    // 下载资源
    public function down() {

        \Phpcmf\Service::V()->assign([
            'cid' => $_GET['cid'],
        ]);
        \Phpcmf\Service::V()->display('cloud_down.html');exit;
    }

    // 服务器统计数量
    function down_count() {

        $cid = ($_GET['cid']);
        $surl = $this->service_url.'&action=down_count&get_http=1&cid='.$cid;
        $json = dr_catcher_data($surl);
        if (!$json) {
            $this->_json(0, '没有从服务端获取到数据');
        }

        $data = dr_string2array($json);
        if (!$data) {
            $this->_json(0, '服务端数据异常，请重新下载：'.$json);
        } elseif (!$data['code']) {
            $this->_json(0, $data['msg']);
        } elseif (dr_count($data['data']['zy']) == 0) {
            $this->_json(0, '程序包中没有文件');
        }

        \Phpcmf\Service::L('cache')->init()->save('zy-cloud-down-'.$cid, $data['data'], 3600);

        $this->_json(dr_count($data['data']['zy']), 'ok');
    }

    // 服务器下载程序
    function down_data() {

        $cid = ($_GET['cid']);
        $page = max(1, intval($_GET['page']));
        $cache = \Phpcmf\Service::L('cache')->init()->get('zy-cloud-down-'.$cid);
        !$cache && $this->_json(0, '授权验证过期，请重试');
        $data = $cache['zy'][$page];

        $this->_module_init('cloud'); //  是模块目录

        $app = \Phpcmf\Service::M('app')->get_config(APP_DIR);
        $catid = $app['cloud']['catid'][$cache['tid']];
        if (!$catid) {
            $this->_json(0, '没有绑定云端关联栏目['.$cache['tid'].']');
        }

        if ($data) {
            $html = '';
            foreach ($data as $t) {
                if (!$t) {
                    $html.= '<p class=""><label class="rleft">没有从服务端获取到数据</label><label class="rright"><span class="error">失败</span></label></p>';
                } else {
                    // 查询
                    $table = SITE_ID.'_cloud';
                    $tableinfo = \Phpcmf\Service::M('Table')->get_field($table);
                    if (!$tableinfo) {
                        $html.= '<p class=""><label class="rleft">无法获取到数据表['.$table.']字段</label><label class="rright"><span class="error">失败</span></label></p>';
                    } else {
                        $row = \Phpcmf\Service::M()->table($table)->where('cloud_id', $t['id'])->getRow();
                        if ($row) {
                            // 更新操作
                            $rt = $this->content_model->update_zy($catid, $row, $t);
                            if ($rt) {
                                $this->_error_msg($t['title'], $rt);
                            }
                            $html.= '<p class=""><label class="rleft">'.$t['title'].'</label><label class="rright"><span class="update">更新成功</span></label></p>';
                        } else {
                            // 新增
                            $rt = $this->content_model->insert_zy($catid, $t);
                            if ($rt) {
                                $this->_error_msg($t['title'], $rt);
                            }
                            $html.= '<p class=""><label class="rleft">'.$t['title'].'</label><label class="rright"><span class="ok">入库成功</span></label></p>';
                        }
                    }
                }
            }
            $this->_json($page + 1, $html);
        }


        $this->_json(100, '');
    }


    // 错误进度
    private function _error_msg($filename, $msg) {
        $html = '<p class=" p_error"><label class="rleft">'.$filename.'</label><label class="rright">'.$msg.'</label></p>';
        $this->_json(0, $html);
    }

}
