<?php namespace Phpcmf\Controllers;

/**
 * 私有云api调用
 */

class Api extends \Phpcmf\Home\Module
{

    public function index() {

        $param = [
            'id' => dr_safe_replace($_GET['id']), //
            'type' => dr_safe_replace($_GET['type']), //
            'admin' => urldecode($_GET['admin']), // 后台地址
            'domain' => dr_safe_replace($_GET['domain']), // 域名
            'action' => dr_safe_replace($_GET['action']), // 事件
            'license' => dr_safe_replace($_GET['license']), // 认证
            'version' => dr_safe_replace($_GET['version']), //
        ];

        if (is_file(MYPATH.'Config/License.php')) {
            $this->license = require MYPATH.'Config/License.php';
            if (!$this->license['license']) {
                exit('程序不是最新，请在官网下载[安装包]并覆盖dayrui目录');
            }
        } else {
            exit('程序需要更新到正式版，请在官网 http://www.xunruicms.com/down/ 下载[安装包]并覆盖dayrui目录');
        }

        if ($param['license'] != $this->license['license']) {
            cloud_msg(0, '你的程序不是来自本公司，访问被禁止');
        }

        switch ($param['action']) {

            case 'update_file':

                list($a, $appid) = explode('-', $_GET['appid']);
                $ls = intval($_GET['ls']);
                if (!$appid) {
                    $this->_json(0, '应用id不能为空');
                } elseif (!$ls) {
                    $this->_json(0, '应用ls参数为空，请更新CMS程序');
                }

                $zname = md5($appid.'-'.$ls).'.zip';
                $down_url = SITE_URL.'cloud_zip/'.$zname;
                $down_file = WEBPATH.'cloud_zip/'.$zname;
                if (!is_file($down_file)) {
                    exit($this->_json(0, dr_lang('程序zip文件不存在，请重新下载')));
                }

                $this->_json(1, 'ok', [
                    'size' => filesize($down_file),
                    'url' => $down_url,
                    'dir' => '',
                ]);
                break;

            case 'check_version':
                // 检测版本
                $url = 'https://www.xunruicms.com/cloud.php?domain='.$param['domain'].'&admin='.urlencode($param['admin']).'&action=check_version&is_syy=1&cms=11&license='.$param['license'].'&get_http=1&id='.$param['id'].'&version='.$param['version'];
                $json = dr_catcher_data($url);
                !$json ? $this->_json(0, '没有从服务端获取到数据') : exit($json);

                break;


            case 'app':
                // app列表

                $tpl = 'list.html';
                $param['catid'] = dr_safe_replace($_GET['catid']);

                $app = \Phpcmf\Service::M('app')->get_config(APP_DIR);
                $catid = $app['cloud']['catid'][$param['catid']];
                if (!$catid) {
                   cloud_msg(0, '没有绑定云端关联栏目['.$param['catid'].']');
                }


                $where = 'status=9 and catid='.$catid.'';

                \Phpcmf\Service::V()->assign([
                    'catid' => $catid,
                    'where' => urlencode($where),
                    'urlrule' => cloud_search_url($param, 'page', '[page]'),
                ]);

                break;


            default:
                \Phpcmf\Service::C()->_json(0, '未定义接口');
                exit;
                break;

        }

        \Phpcmf\Service::V()->admin();
        \Phpcmf\Service::V()->assign([
            'param' => $param,
        ]);
        \Phpcmf\Service::V()->display('api/'.$tpl);exit;

    }

}


// 错误提示
function cloud_msg($id, $msg, $url = '') {

    if (IS_POST || IS_AJAX_POST) {
        \Phpcmf\Service::C()->_json($id, $msg, $url);
    } else {

        \Phpcmf\Service::V()->admin();
        \Phpcmf\Service::V()->assign([
            'msg' => $msg,
            'mark' => $id,
            'url' => $url,
        ]);
        \Phpcmf\Service::V()->display('api/msg.html');
    }
  	exit;
}

// 云平台搜索地址
function cloud_search_url($param, $name, $value) {

    if (!$value) {
        unset($param[$name]);
    } else {
        $param[$name] = $value;
    }

    return SELF.'?s=cloud&c=api&'.http_build_query($param);
}

// 云平台地址
function cloud_url($param, $action, $name = '', $value = '') {

    if ($name) {
        if (!$value) {
            unset($param[$name]);
        } else {
            $param[$name] = $value;
        }
    }

    $param['action'] = $action;

    return SELF.'?s=cloud&c=api&'.http_build_query($param);
}
