<?php namespace Phpcmf\Controllers;

class Buy extends \Phpcmf\Home\Module
{
    
    public function __construct(...$params)
    {
        parent::__construct(...$params);


        $this->_module_init();

        if (!$this->uid) {
            $this->_msg(0, '你没有登录');
        }
    }

    // 
    public function index() {

        $id = intval($_GET['id']);
        $shop = \Phpcmf\Service::M()->table_site('cloud')->where('id', $id)->getRow();
        if (!$shop) {
            $this->_msg(0, '此应用不存在');
        } elseif ($shop['status'] != 9) {
            $this->_msg(0, '此应用已经下架');
        }
        
        // 判断云端应用重复购买
        if (in_array($shop['catid'], $this->app_config['cloud']['catid'])) {
            $buy = \Phpcmf\Service::M()->table_site('cloud_buy')->where('uid', $this->uid)->where('cid', $shop['id'])->getRow();
            if ($buy) {
                if ($buy['status'] == -1) {
                    $this->_msg(1, '你已经下单了，请到用户中心完成付款', dr_member_url('cloud/my/index'));
                } else {
                    //$this->_msg(0, '你已经购买过了，无需重复购买');
                }
            }
        }

        $field = $this->content_model->get_buy_field($shop['catid']);

        if (IS_POST) {
            $post = \Phpcmf\Service::L('input')->post('data');
            list($post, $return, $attach) = \Phpcmf\Service::L('Form')->validation($post, [], $field, []);
            // 输出错误
            $return && $this->_json(0, $return['error'], ['field' => $return['name']]);
            $save = [
                'uid' => $this->member['uid'],
                'cid' => $shop['id'],
                'catid' => $shop['catid'],
                'cloud_id' => $shop['cloud_id'],
                'price' => $shop['price'],
                'inputtime' => SYS_TIME,
                'endtime' => 0,
                'domain' => '',
                'error' => '未付款',
                'status' => -1,
            ];
            if ($post[1]) {
                $save = dr_array22array($save, $post[1]);
            }
            $rt = \Phpcmf\Service::M()->table(SITE_ID.'_cloud_buy')->insert($save);
            !$rt['code'] && $this->_json(0, $rt['msg'], $rt['data']);
            // 附件归档
            SYS_ATTACHMENT_DB && $attach && \Phpcmf\Service::M('Attachment')->handle($this->member['id'], \Phpcmf\Service::M()->dbprefix(SITE_ID.'_cloud_buy-'.$rt['code']), $attach);
            if ($shop['price'] > 0) {
                // 付款界面
                $this->_json(1, '下单成功', [
                    'url' => dr_url('cloud/buy/pay', ['id' => $rt['code']])
                ]);
            } else {
                \Phpcmf\Service::M()->table(SITE_ID.'_cloud_buy')->update($rt['code'], [
                    'inputtime' => SYS_TIME,
                    'endtime' => SYS_TIME + YEAR,
                    'error' => '',
                    'status' => 1,
                ]);
                $this->_json(1, '购买成功', [
                    'url' => dr_member_url('cloud/my/show', ['id' => $rt['code']])
                ]);
            }
        }

        \Phpcmf\Service::V()->assign([
            'data' => $shop,
            'price' => $shop['price'],
            'myfield' => \Phpcmf\Service::L('Field')->toform(0, $field, []),
            'meta_title' => '下单购买'.SITE_SEOJOIN.$shop['title'],
        ]);
        \Phpcmf\Service::V()->display('order.html');
        
    }
    
    public function pay() {

        $id = intval($_GET['id']);
        $data = \Phpcmf\Service::M()->db->table(SITE_ID.'_cloud_buy')->where('id', $id)->get()->getRowArray();
        if (!$data) {
            $this->_msg(0, '购买记录不存在');
        } elseif ($data['status'] != -1) {
            $this->_msg(0, '此应用已经付款了');
        }

        $shop = \Phpcmf\Service::M()->db->table(SITE_ID.'_cloud')->where('id', $data['cid'])->get()->getRowArray();
        if (!$shop) {
            $this->_msg(0, '此应用不存在');
        } elseif ($shop['status'] != 9) {
            $this->_msg(0, '此应用已经下架');
        }

        if ($data['price'] > 0) {
            // 付费模板购买模式
            define('FC_PAY', 1);
            \Phpcmf\Service::V()->assign([
                'data' => $shop,
                'price' => $shop['price'],
                'payform' => dr_payform("my-cloud_buy-".$id),
                'meta_title' => '在线付款'.SITE_SEOJOIN.$shop['title'],
            ]);
            \Phpcmf\Service::V()->display('buy.html');
        } else {
            // 免费直接下载
            $this->_msg(1, '此应用是免费的，无需付款');
        }
    }

}
