<?php namespace Phpcmf\Controllers;

class Down extends \Phpcmf\Home\Module
{

    public function index() {

        $this->_module_init();

        if (!$this->uid) {
            $this->_msg(0, '你没有登录');
        }

        $id = intval($_GET['id']);
        $data = \Phpcmf\Service::M()->db->table(SITE_ID.'_cloud')->where('id', $id)->get()->getRowArray();
        if (!$data) {
            $this->_msg(0, '此应用不存在');
        } elseif ($data['status'] != 9) {
            $this->_msg(0, '此应用已经下架');
        } elseif (!dr_is_down_shop($data['catid'])) {
            $this->_msg(0, '此应用不允许下载');
        }

        // 判断
        $buy = \Phpcmf\Service::M()->db->table(SITE_ID.'_cloud_buy')->where('uid', $this->uid)->where('cid', $id)->get()->getRowArray();
        if (!$buy) {
            $this->_msg(0, '你没有购买此应用');
        } elseif ($buy['status']!=1) {
            $this->_msg(0, '此应用未购买成功，无法下载');
        } elseif ($buy['endtime'] < SYS_TIME) {
            $this->_msg(0, '此应用已过期，无法下载');
        }

        //
        if ($data['cloud_id']) {
            // 云端记录
            $rt = \Phpcmf\Service::M('zy', 'cloud')->down_zip($data['cloud_id'], $buy['id'], $this->uid);
            if (is_array($rt) && !$rt['code']) {
                $this->_msg(0, '云端：'.$rt['msg']);
            }

            if (!$rt) {
                $this->_msg(0, dr_lang('文件下载失败'));
            }

            $zipfile = WRITEPATH.'cloud/'.md5($id.$this->member['id']).'.zip';
          	dr_mkdirs(WRITEPATH.'cloud/');
            file_put_contents($zipfile, $rt);

            if (!is_file($zipfile)) {
                exit($this->_msg(0, dr_lang('安装包同步下载失败，请联系客服')));
            }
        } else {
            // 本地文件
            $zz = \Phpcmf\Service::C()->get_attachment($data['file']);
            if (!$zz) {
                $this->_msg(0, '未上传程序，请联系官方');
            } elseif (!is_file($zz['file'])) {
                $this->_msg(0, '程序文件('.$zz['file'].')不存在，请联系官方');
            }
            $zipfile = $zz['file'];

        }

        // 生成的文件
        $savepath = WRITEPATH.'cloud/'.md5($id.$this->member['id']).'/';
        dr_mkdirs($savepath);

        $savepath = $this->_zip_jie($zipfile, $savepath);
        if (!is_dir($savepath)) {
            $this->_msg(0, '未上传程序，请联系官方2');
        }

        // 生成版本号
        if (is_dir($savepath.'APPSPATH/')) {
            $p = dr_dir_map($savepath.'APPSPATH/', 1);
            foreach ($p as $name) {
                if (is_file($savepath.'APPSPATH/'.$name.'/Config/App.php')) {
                    $ls = require MYPATH.'Config/License.php';
                    file_put_contents($savepath.'/APPSPATH/'.$name.'/Config/Version.php', $this->_app_version(
                        $data['id'],
                        $data['version'],
                        $ls['license'],
                        $data['updatetime']
                    ));
                    if (is_file($savepath.'APPSPATH/'.$name.'/install.lock')) {
                        unlink($savepath.'APPSPATH/'.$name.'/install.lock');
                    }
                    break;
                }
            }
        }

        // 离线目录重新部署
        $newpath = WRITEPATH.'cloud/'.md5($id.$this->member['id']).'_zip/';
        dr_mkdirs($newpath);


        // 复制文件到程序
        if (is_dir($savepath.'APPSPATH')) {
            $this->_copy_dir($savepath.'APPSPATH', $newpath.'dayrui/App/');
        }
        if (is_dir($savepath.'WEBPATH')) {
            $this->_copy_dir($savepath.'WEBPATH', $newpath);
        }
        if (is_dir($savepath.'ROOTPATH')) {
            $this->_copy_dir($savepath.'ROOTPATH', $newpath);
        }
        if (is_dir($savepath.'CSSPATH')) {
            $this->_copy_dir($savepath.'CSSPATH/', $newpath.'static/');
        }
        if (is_dir($savepath.'TPLPATH')) {
            $this->_copy_dir($savepath.'TPLPATH', $newpath.'template/');
        }
        if (is_dir($savepath.'WRITEPATH')) {
            $this->_copy_dir($savepath.'WRITEPATH', $newpath.'cache/');
        }
        if (is_dir($savepath.'FCPATH')) {
            $this->_copy_dir($savepath.'FCPATH', $newpath.'dayrui/');
        }
        if (is_dir($savepath.'MYPATH')) {
            $this->_copy_dir($savepath.'MYPATH', $newpath.'dayrui/My/');
        }
        if (is_dir($savepath.'COREPATH')) {
            $this->_copy_dir($savepath.'COREPATH', $newpath.'dayrui/Core/');
        }

        //

        $zfile = WRITEPATH.'cloud/'.md5($id.$this->member['id']).'.zip';
        @unlink($zfile);

        // 设置权限
        $iterator = new \RecursiveIteratorIterator(new \RecursiveDirectoryIterator($newpath));
        foreach($iterator as $item) {
            chmod($item, 0777);
        }

        $zip = new \ZipArchive();

        if(!$zip->open($zfile, \ZipArchive::CREATE))
        {
            exit($this->_msg(0, dr_lang('创建zip失败，请联系客服')));
        }

        \Phpcmf\Service::C()->temp['lxxz'] = 0;
        $this->_createZip(opendir($newpath),$zip,$newpath);
        $zip->close();
        if (\Phpcmf\Service::C()->temp['lxxz'] == 0) {
            exit($this->_msg(0, dr_lang('安装包存在问题（空包/无权限），请联系客服')));
        }

        if (!is_file($zfile)) {
            exit($this->_msg(0, dr_lang('安装包打包失败，请联系客服')));
        }

        dr_dir_delete($newpath); // 清空目录
        dr_dir_delete($savepath); // 清空目录


        if ($_GET['domain']) {

            $zname = md5($data['id'].'-'.$this->uid).'.zip';
            $down_path = WEBPATH.'cloud_zip/';
            dr_mkdirs($down_path);
            if (!is_dir($down_path)) {
                exit($this->_msg(0, dr_lang('网站根目录无创建目录的权限')));
            }
            copy($zfile, $down_path.$zname);
            if (!is_file($down_path.$zname)) {
                exit($this->_msg(0, dr_lang('网站根目录无写入文件权限')));
            }

            dr_redirect(urldecode($_GET['domain']).'?c=cloud&m=down_file&ls='.$this->member['id'].'&cid='.$data['id']);
            // exit
            exit;
        }

        $name = urlencode(dr_cat_value('cloud', $data['catid'], 'name').'-'.trim($data['title']).'-v'.$data['version'].'.zip');

        $filesize = filesize($zfile);
        $handle = fopen($zfile,"rb");
        if (FALSE === $handle) {
            $this->_msg(0, dr_lang('文件已经损坏'));
        }

        header("Content-Type: application/zip"); //zip格式的
        header("Accept-Ranges:bytes");
        header("Accept-Length:".$filesize);
        header( "Content-Disposition:  attachment;  filename= {$name}");

        $contents = '';
        while (!feof($handle)) {
            $contents = fread($handle, 8192);
            echo $contents;
            @ob_flush();  //把数据从PHP的缓冲中释放出来
            flush();      //把被释放出来的数据发送到浏览器
        }
        fclose($handle);
        exit;

    }

    // zip解压 返回目录
    function _zip_jie($file, $path) {

        if (!$file) {
            $this->_msg(0, '服务端文件没有上传，请联系官方人员');
        }

        if (!\Phpcmf\Service::L('file')->unzip($file, $path)) {
            $this->_msg(0, '服务端文件解压失败，请联系官方人员');
        }

        return $path;
    }

    function _createZip($openFile,$zipObj,$sourceAbso,$newRelat = '')
    {
        while(($file = readdir($openFile)) != false)
        {
            if($file=="." || $file=="..")
                continue;

            /*源目录路径(绝对路径)*/
            $sourceTemp = $sourceAbso.'/'.$file;
            /*目标目录路径(相对路径)*/
            $newTemp = $newRelat==''?$file:$newRelat.'/'.$file;
            if(is_dir($sourceTemp))
            {
                //echo '创建'.$newTemp.'文件夹<br/>';
                $zipObj->addEmptyDir($newTemp);/*这里注意：php只需传递一个文件夹名称路径即可*/
                $this->_createZip(opendir($sourceTemp),$zipObj,$sourceTemp,$newTemp);
            }
            if(is_file($sourceTemp))
            {
                //echo '创建'.$newTemp.'文件<br/>';
                $zipObj->addFile($sourceTemp,$newTemp);
                \Phpcmf\Service::C()->temp['lxxz']++;
            }
        }
    }

    function _copy_dir($src, $dst) {

        $dir = opendir($src);
        if (!is_dir($dst)) {
            @mkdir($dst);
        }

        $src = rtrim($src, '/');
        $dst = rtrim($dst, '/');

        while(false !== ( $file = readdir($dir)) ) {
            if (( $file != '.' ) && ( $file != '..' )) {
                if (is_dir($src . '/' . $file) ) {
                    dr_mkdirs($dst . '/' . $file);
                    $this->_copy_dir($src . '/' . $file, $dst . '/' . $file);
                    continue;
                } else {
                    dr_mkdirs(dirname($dst . '/' . $file));
                    $rt = copy($src . '/' . $file, $dst . '/' . $file);
                    !$rt && $this->_msg(0, '移动失败<br>'.$dst . '/' . $file. '<br>'.$src . '/' . $file);
                }
            }
        }
        closedir($dir);
    }


// app 生成版本文件
    function _app_version($appid, $version, $license, $updatetime) {

        $text = "<?php

return [

    'id' => '".$appid."',
    'version' => '".$version."',
    'license' => '".$license."',
    'updatetime' => '".date('Y-m-d', $updatetime)."',
    'downtime' => '".date('Y-m-d', SYS_TIME)."',

];
";
        return $text;
    }

}
