<?php namespace Phpcmf\Controllers\Member;


// 交易记录
class My extends \Phpcmf\Table
{

    public function __construct(...$params)
    {
        parent::__construct(...$params);
        // 支持附表存储
        $this->is_data = 0;
        // url显示名称
        $this->name = dr_lang('交易记录');
        // 初始化数据表
        $this->_init([
            'table' => SITE_ID.'_cloud_buy',
            'select_list' =>  SITE_ID.'_cloud_buy.*,'.SITE_ID.'_cloud.title,'.SITE_ID.'_cloud.url',
            'order_by' => SITE_ID.'_cloud_buy.id desc',
            'join_list' => [SITE_ID.'_cloud', SITE_ID.'_cloud_buy.cid='.SITE_ID.'_cloud.id', 'left'],
            'where_list' => SITE_ID.'_cloud_buy.uid='.$this->uid,
        ]);
    }

    // 后台查看url列表
    public function index() {
        $this->_List();
        \Phpcmf\Service::V()->display('my_list.html');
    }

    public function show() {

        $id = intval($_GET['id']);
        $data = \Phpcmf\Service::M()->db->table(SITE_ID.'_cloud_buy')->where('id', $id)->get()->getRowArray();
        if (!$data) {
            $this->_msg(0, '购买记录不存在');
        } elseif ($data['uid'] != $this->uid) {
            $this->_msg(0, '无权限查看订单');
        }

        $shop = \Phpcmf\Service::M()->db->table(SITE_ID.'_cloud')->where('id', $data['cid'])->get()->getRowArray();

        $this->_module_init('cloud');
        $field = $this->content_model->get_buy_field($shop['catid']);

        \Phpcmf\Service::V()->assign([
            'shop' => $shop,
            'order' => $data,
            'myfield' => \Phpcmf\Service::L('Field')->toform($id, $field, $data, 1),
        ]);
        \Phpcmf\Service::V()->display('my_show.html');
    }

    public function xf() {

        $this->_json(0, '开发中');

        $id = intval($_GET['id']);
        $data = \Phpcmf\Service::M()->table(SITE_ID.'_cloud_buy')->get($id);
        if (!$data) {
            $this->_json(0, '交易记录不存在');
        }
        $shop = \Phpcmf\Service::M()->table(SITE_ID.'_cloud')->get($data['cid']);
        if (!$shop) {
            $this->_json(0, '商品['.$data['cid'].']不存在');
        } elseif ($shop['status'] != 9) {
            $this->_json(0, '商品['.$shop['title'].']已下架');
        }

        // 打钱
        \Phpcmf\Service::M('member')->add_money($shop['uid'], $data['price2']);
        // 增加到交易流水
        \Phpcmf\Service::M('Pay')->add_paylog([
            'uid' => $shop['uid'],
            'username' => $shop['author'],
            'touid' => $this->member['id'],
            'tousername' => $this->member['username'],
            'mid' => 'shop',
            'title' => '应用市场【'.$shop['title'].'】售价['.$data['price'].']，扣除交易费到账['.$data['price2'].']',
            'value' => $data['price2'],
            'type' => 'finecms',
            'status' => 1,
            'result' => '',
            'paytime' => SYS_TIME,
            'inputtime' => SYS_TIME,
        ]);

        \Phpcmf\Service::M()->table(SITE_ID.'_cloud_buy')->update($id, [
            'is_dz' => 1,
        ]);

        $this->_json(1, '申请到账成功', [
            'url' => dr_member_url('shop/order/index')
        ]);

    }

}
