<?php namespace Phpcmf\Model\Cloud;

class Zy extends \Phpcmf\Model {

    private $admin_url;
    private $service_url;
    private $license_sn;

    public function __construct(...$params)
    {
        parent::__construct(...$params);
        $ls = require MYPATH.'Config/License.php';
        $this->license_sn = $ls['license'];
        list($this->admin_url) = explode('?', FC_NOW_URL);
        $this->service_url = 'https://www.xunruicms.com/cloud-zy.php?domain='.dr_get_domain_name(ROOT_URL).'&admin='.urlencode($this->admin_url).'&license='.$this->license_sn;
    }

    public function get_service_url() {
        return $this->service_url;
    }

    public function signature($params) {

        $secret = $this->license_sn;

        $str = '';  //待签名字符串
        //先将参数以其参数名的字典序升序进行排序
        ksort($params);
        //遍历排序后的参数数组中的每一个key/value对
        foreach ($params as $k => $v) {
            //为key/value对生成一个key=value格式的字符串，并拼接到待签名字符串后面
            $str .= $k . $v;
        }
        //将签名密钥拼接到签名字符串最后面
        $str .= $secret;
        //通过md5算法为签名字符串生成一个md5签名，该签名就是我们要追加的sign参数值
        return md5($str);
    }

    // 购买时的通信
    public function tx($data) {

        $url = $this->get_service_url().'&action=buy&get_http=1&data='.dr_array2string($data).'&ls='.$this->signature($data);
        $json = dr_catcher_data($url);
        if (!$json) {
            return dr_return_data(0, '服务器返回数据为空');
        }

        $rt = dr_string2array($json);
        if (!$rt) {
            return dr_return_data(0, '服务器返回数据异常');
        }

        return $rt;
    }

    public function down_zip($id, $oid, $uid) {

        $url = $this->get_service_url().'&action=down_app&get_http=1&id='.$id.'&uid='.$uid.'&oid='.$oid;
        $json = dr_catcher_data($url);
        if (!$json) {
            return dr_return_data(0, '服务器返回数据为空');
        }
        $rt = dr_string2array($json);
        if ($rt && !$rt['code']) {
            return dr_return_data(0, $rt['msg']);
        }
        return $json;
    }


}