<?php namespace Phpcmf\Controllers\Member;
/* *
 *
 * 本TableDemo的语法参考： http://help.phpcmf.net/445.html
 *
 * */
class My extends \Phpcmf\Table
{

    public function __construct(...$params)
    {
        parent::__construct(...$params);
        // 判断云市场
        if (!dr_is_app('cloud')) {
            $this->_admin_msg(0, '你没有安装[私有云市场]插件，请在插件商城中安装它');
        }
        $cloud = \Phpcmf\Service::M('app')->get_config('cloud');
        if (!isset($cloud['cloud']['catid'][58]) || !$cloud['cloud']['catid'][58]) {
            $this->_admin_msg(0, '需要在[私有云市场]插件的-云端关联-关联小程序栏目');
        }
        $this->catid = intval($cloud['cloud']['catid'][58]);
        $module = $this->get_cache('module-'.SITE_ID.'-cloud');
        $category = $module['category'][$this->catid];
        if (!$category) {
            $this->_admin_msg(0, '[私有云市场]插件的小程序栏目['.$this->catid.']不存在');
        }
        // 表单显示名称
        $this->name = dr_lang('小程序');
        // 模板前缀(避免混淆)
        $this->tpl_prefix = 'my_';
        // 用于表储存的字段，后台可修改的表字段
        // 初始化数据表
        $this->_init([
            'table' => 'xcx',  // （不带前缀的）表名字
            'select_list' => 'xcx.*,'.SITE_ID.'_cloud_buy.price,'.SITE_ID.'_cloud_buy.inputtime,'.SITE_ID.'_cloud_buy.endtime,'.SITE_ID.'_cloud_buy.cloud_id',
            'join_list' => [SITE_ID.'_cloud_buy', 'xcx.oid='.SITE_ID.'_cloud_buy.id', 'left'], // 可查询的字段
            'order_by' => 'xcx.id desc', // 列表排序，默认的排序方式
            'date_field' => '', // 按时间段搜索字段，没有时间字段留空
            'where_list' => 'xcx.uid='.$this->uid,
        ]);// 把公共变量传入模板
        \Phpcmf\Service::V()->assign([
            'catid' => $this->catid,
        ]);
    }

    // 查看列表
    public function index() {
        list($tpl) = $this->_List();
        \Phpcmf\Service::V()->display($tpl);
    }

    /**
     * 获取内容
     * $id      内容id,新增为0
     * */
    protected function _Data($id = 0) {
        $row = parent::_Data($id);
        // 这里可以对内容进行格式化显示操处理
        return $row;
    }



}
